#!/usr/bin/perl

$gBaseURL = ".";
$gIconURL = "./images";
$gBaseDIR = ".";
$gCGI_URL = "./wj_notice.cgi";

$gMakeBoard = "Y";

$gLockFlag = "N";
$gLockStat = "N";

umask(000);
&parseArgument;
sub parseArgument {
	local($buffer,$data,$name,$value);
	local(@datum);

	if($ENV{'REQUEST_METHOD'} eq "GET") {
		$buffer = $ENV{'QUERY_STRING'};
	}
	else {
		read(STDIN,$buffer,$ENV{'CONTENT_LENGTH'});
	}

	@datum = split(/&/,$buffer);

	foreach $data (@datum) {
		($name,$value) = split(/=/,$data);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9]{2})/pack("C",hex($1))/eg;
		$FORM{$name} = $value;
	}
	if($FORM{'id'}) {
		$gBaseDIR = "$gBaseDIR/$FORM{'id'}";
		$gPgTitle = "<img src=$gIconURL/$FORM{'id'}.gif>";
		$gNumFile = "$FORM{'id'}.num";
		$gCfgFile = "$FORM{'id'}.cfg";
		$gPwdFile = "$FORM{'id'}.pwd";
		$gDatFile = "$FORM{'id'}.idx";
	}
	else {
		&HTMLHeader;

		print "<form name=id>\n";
		print "<table border cellpadding=3 cellspacing=0 width=300 bgcolor=#f3f3f3 bordercolordark=#ffffff bordercolorlight=#c0c0c0>\n";
		print "<tr><td bgcolor=#e3e3e3 align=center><font style=\"font-size:9pt\"> notice cgi </font></td></tr>\n";
		print "<tr><td height=40 align=center><font style=\"font-size:9pt\">  DB  </font><input type=text name=id size=15 class=ad value=$DBname></td></tr>\n";
		print "<tr><td bgcolor=#e3e3e3 align=center>\n";
		print "<input type=submit value=\" DB  \" style=\"height:18px;font-size:9pt;background:#f3f3f3;border:1 solid #787878;cursor: hand\" OnClick=\"url_go('$gCGI_URL?id=$DBname')\">\n";
		print "</table></td></tr></table>\n";
		print "</form>\n";

		&HTMLFooter;
	}
	if(open(HANDLE,"<$gBaseDIR/$gNumFile")) {
		close(HANDLE);
		&selectAction;
	}
	else {
		if($gMakeBoard eq "Y") {
			&selectAction;
		}
		else {
			&HTMLHeader;
				print "<font style=\"font-size:9pt\">ڿ   Ǿ ϴ!</font>\n";
			&HTMLFooter;
		}
	}
}

sub selectAction {
	&getNumber;
	&getEnvVar;

	if($FORM{'p'}) {
		$gCurPage = $FORM{'p'};
	}
	else {
		$gCurPage = "1";
	}

	$gTotPage = int(($gNoOfData-1)/$gRecPerPage)+1;

	unless($FORM{'action'}) {
		$FORM{'action'} = "read";
	}
	if($FORM{'action'} eq "read") {	
		&readData;
	} 
	elsif($FORM{'action'} eq "input_form") {
		&checkAdminPassword;
		&showInputForm;
	}
	elsif($FORM{'action'} eq "write") {
		&writeData;
	} 
	elsif($FORM{'action'} eq "delete") {
		&checkUserPassword;
		&deleteData;
	} 
	elsif($FORM{'action'} eq "update_form") {
		&checkUserPassword;
		&showUpdateForm;
	} 
	elsif($FORM{'action'} eq "update") {
		&updateData;
	} 
	elsif($FORM{'action'} eq "users_login") {
		&showUsersLogin;
	}
	elsif($FORM{'action'} eq "admin_login") {
		&showAdminLogin;
	}
	elsif($FORM{'action'} eq "config_form") {
		&checkAdminPassword;
		&showConfigForm;
	}
	elsif($FORM{'action'} eq "config") {
		&updateEnvVar;
	}
	elsif($FORM{'action'} eq "search") {
		&searchData;
	}
	else {
		exit;
	}
}

sub getNumber {
	if(open(HANDLE,"<$gBaseDIR/$gNumFile")) {
		$gNoOfData = <HANDLE>;
		close(HANDLE);
		chop($gNoOfData);

		open(HANDLE,"<$gBaseDIR/$gDatFile");
			@datum = <HANDLE>;
		close(HANDLE);
		if($gNoOfData != $#datum) {
			$gNoOfData = $#datum;
			&putNumber;
		}
	}
	else {
		mkdir("$gBaseDIR",0777);  
		mkdir("$gBaseDIR/messages",0777);

		open(HANDLE,">$gBaseDIR/$gDatFile");
			print HANDLE "<!--EOF-->\n";
		close(HANDLE);

		$gNoOfData = "0";
		&putNumber;
	} 
}

sub putNumber {
	open(HANDLE,">$gBaseDIR/$gNumFile");
		print HANDLE "$gNoOfData\n";
	close(HANDLE);
}

sub getEnvVar {
	local($env_list);
	local(@datum);

	if(open(HANDLE,"<$gBaseDIR/$gCfgFile")) {
		$env_list = <HANDLE>;
		close(HANDLE);
		@datum = split(/\|/,$env_list);

		$gBackColor = $datum[1];
		$gBackImage = $datum[2];
		$gBoardTitle = $datum[3];
		$gBoardImage = $datum[4];
		$gTableWidth = $datum[5];
		$gRecPerPage = $datum[6];
		$gListNumber = $datum[7];
		$gBaseText = $datum[8];
		$gTextSize = $datum[9];
		$gTextFamily = $datum[10];
		$gLink = $datum[11];
		$gLinkVisited = $datum[12];
		$gLinkActive = $datum[13];
		$gLinkHover = $datum[14];
		$gSubjectText = $datum[15];
		$gContentText = $datum[16];
		$gDateText = $datum[17];

		chop($gHomeImageURL);
    }
	else {

		$gBackColor = "#ffffff";
		$gBackImage = "";
		$gBoardTitle = "";
		$gBoardImage = "";
		$gTableWidth = "400";
		$gRecPerPage = "5";
		$gListNumber = "5";
		$gBaseText = "#787878";
		$gTextSize = "9pt";
		$gTextFamily = ",Tahoma";
		$gLink = "#787878";
		$gLinkVisited = "#787878";
		$gLinkActive = "#505050";
		$gLinkHover = "#c0c0c0";
		$gSubjectText = "#505050";
		$gContentText = "#787878";
		$gDateText = "#505050";

		&putEnvVar;
	}
}
 
sub putEnvVar {
	open(HANDLE,">$gBaseDIR/$gCfgFile");
		print HANDLE "^^|$gBackColor|$gBackImage|$gBoardTitle|$gBoardImage|$gTableWidth|$gRecPerPage|$gListNumber|$gBaseText|$gTextSize|$gTextFamily|$gLink|$gLinkVisited|$gLinkActive|$gLinkHover|$gSubjectText|$gContentText|$gDateText|\n";
	close(HANDLE);
}

sub readData {
	&HTMLHeader;
	&PageHeader;
	&readIndexFile;
	&MenuButton;
	&PageFooter;
	&HTMLFooter;
}

sub readIndexFile {
	local($i,$j,$actual_number,$short_subject,$short_date,$old_date,$new_date);
	local(@datum,@value);

	open(HANDLE,"$gBaseDIR/$gDatFile");
		@datum = <HANDLE>;
	close(HANDLE);
	$old_date = substr($value[5],0,10);
	&getDate;
	$new_date = substr($date,0,10);

	for($i=($gCurPage-1)*$gRecPerPage+1;$i<=($gCurPage-1)*$gRecPerPage+$gRecPerPage;$i++) {
		@value = split(/\|/,$datum[$i]);    
		$actual_number = ($gNoOfData+1)-$i;
		$old_date = substr($value[5],0,10);
		&getDate;
		$new_date = substr($date,0,10);

		if($actual_number > 0) {
			$date_length = length($value[5]);
			if ($date_length > 18) {
				$short_date = substr($value[5],0,10);
			}
			else {
				$short_date = substr($value[5],0,8);
				$short_date = '19'.$short_date;
			}
			print "<table width=$gTableWidth border=0 cellpadding=0 cellspacing=0>\n";
			print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
			print "<tr><td><table width=100% border=0 cellspacing=0 cellpadding=4>\n";  
			print "<tr><td><img src=$gIconURL/info.gif border=0> <b><a href=$gCGI_URL?id=$FORM{'id'}&action=users_login&p=$FORM{'p'}&c=update_form&l=$value[1] title=\"ϱ\"><font style=\"color:$gDateText\">$short_date</font></a>\n";
			print " <a href=$gCGI_URL?id=$FORM{'id'}&action=users_login&p=$FORM{'p'}&c=delete&l=$value[1] title=\"ϱ\"><font style=\"color:$gSubjectText\">$value[2]</font></a></b>\n";
			print "<tr><td><div style=line-height:140%><font style=\"color:$gContentText\">$value[7]</font></div>";
			if ($value[4] eq "") {
				print "";
			}
			else {
				print "<br><br><div align=right><img src=$gIconURL/here.gif border=0> <a href=\"$value[4]\" target=\"_blank\" title=\" ũ\"><font size=1 face=Tahoma><b>$value[4]</b></font></a></div>\n";
			}
			print "</table></td></tr></table>\n";
		}
	}
	unless($gNoOfData) {
		print "<table width=$gTableWidth border=0 cellspacing=0 cellpadding=6 align=center>\n";
		print "<tr align=center><td>ϵ Խù ϴ!.\n";
		print "</table><br>\n";
	}
}

sub MenuButton {
	local($PrevPage,$NextPage);
	print "<table width=$gTableWidth border=0 cellpadding=0 cellspacing=0>\n";
	print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
	print "<table border=0 cellpadding=4 cellspacing=0 width=$gTableWidth align=center><tr><td align=left><font size=1 face=Tahoma>";
	$term = $gListNumber;$f = 1;$l = $term;while ($f <= $gTotPage) {
		if (($f <= $gCurPage) && ($gCurPage <= $l)){
			$prevp = $f - 1;
			if ($prevp > 0) {
				print "[<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$prevp>prev</a>]..";
			}
			else {
				print "";
			}
			if ($l <= $gTotPage) {
				for ($page = $f; $page <= $l; $page++) {
					if ($page == $gCurPage) {
						print "[<b>$page</b>]";
					}
					else {
						print "[<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$page>$page</a>]";
					}
				}
			}
			else {
				for ($page = $f; $page <= $gTotPage; $page++) {
					if ($page == $gCurPage) {
						print "[<b>$page</b>]";
					}
					else {
						print "[<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$page>$page</a>]";
					}
				}
			}
			$nextp = $l + 1;
			if ($nextp <= $gTotPage) {
				print "..[<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$nextp>next</a>]";
			}
			else {
				print "";
			}    
		}
		$f = $f + $term;
		$l = $l + $term;
	}
	### Ʒ  ΰ  ! ###
	print "</font><td align=right><font size=1 face=Tahoma>Created by<a href=http://soback.kornet21.net/~zeusso target=_blank title=\" ϴ Ȩ \"> wonie</a> - <a href=http://www.khim.pe.kr/ target=_blank title=\"  Ȩ \">Khim</a>\n";
	print "</td></tr></table>\n";
}

sub HTMLHeader {
	print "Content-type: text/html\n\n";
	print "<!-------------------------------------------------------->\n";
	print "<!--                                                    -->\n";
	print "<!--    ƾ: ̼                                -->\n";
	print "<!--    ڿ: zeusso\@nownuri.net                    -->\n";
	print "<!--    Ȩ: http://soback.kornet21.net/~zeusso    -->\n";
	print "<!--                                                    -->\n";
	print "<!--    ƾ:                                 -->\n";
	print "<!--    ڿ: thief\@khim.pe.kr                      -->\n";
	print "<!--    Ȩ: http://www.khim.pe.kr/                -->\n";
	print "<!--                                                    -->\n";
	print "<!-------------------------------------------------------->\n";
	print "<html>\n";
	print "<head>\n";
	print "    <title> notice.cgi </title>\n";
	print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-KR\">\n";
	print "<style type='text/css'>\n";
	print "<!--\n";
	print "    a:link    { color:$gLink; text-decoration:none }\n" ;
	print "    a:visited { color:$gLinkVisited; text-decoration:none }\n" ;
	print "    a:active  { color:$gLinkActive; text-decoration:none }\n" ;
	print "    a:hover   { color:$gLinkHover; text-decoration:underline }\n";
	print "    body      { background:$gBackColor; background-attachment: fixed; background-image: url($gBackImage); background-repeat: no-repeat; background-position: right bottom }\n";
	print "    body,p,td { color:$gBaseText; font-size:$gTextSize; font-family:$gTextFamily }\n";
	print "    select,input,form,textarea,option { color:$gBaseText; font-size:$gTextSize }\n";
	print "    body {\n";
	print "        scrollbar-face-color:#ffffff;\n";
	print "        scrollbar-shadow-color:#787878;\n"; 
	print "        scrollbar-highlight-color:#f3f3f3;\n"; 
	print "        scrollbar-3dlight-color:#ffffff;\n"; 
	print "        scrollbar-darkshadow-color:#ffffff;\n"; 
	print "        scrollbar-track-color:#ffffff;\n";
	print "        scrollbar-arrow-color:#787878\n";
	print "}\n";
	print "</style>\n";
	print "<script language=\"JavaScript\">\n";
	print "    function nextWin(){\n";
	print "        location = \"$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}\"\n";
	print "}\n";
	print "</script>\n";
	print "<script language=javascript>\n";
	print "    function clearField(field){\n";
	print "        if (field.value == field.defaultValue) {\n";
	print "            field.value = '';\n";
	print "     }\n";
	print "}\n";
	print "    function checkField(field){ \n";
	print "        if (field.value == '') {\n";
	print "            field.value = field.defaultValue;\n";
	print "     }\n";
	print "}\n";
	print "</script>\n";
	print "</head>\n";

	if($gDelayTime == 0) {
		print "<body topmargin=15>\n";
	}
	else {
		print "<meta http-equiv=refresh content=1;url=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}>\n";
		print "<body topmargin=15>\n";
	}
	print "<center>\n";    
	if($gBoardImage) {
		print "<img src=$gBoardImage>\n";
	}
	else {
		print "<table border=0 cellspacing=0 cellpadding=0><tr align=center><td>$gBoardTitle</td></tr></table>\n";
	}
	print "<br>\n";
}

sub HTMLFooter {
	print "</center>\n";
	print "</body>\n";
	print "</html>\n";
	exit;
}

sub PageHeader {
	print "<table width=$gTableWidth border=0 cellpadding=2 cellspacing=0>\n";
	print "<tr><td align=left>\n";
	print "<font size=1 face=Tahoma><a href=$gCGI_URL?id=$FORM{'id'}&action=admin_login&p=$gCurPage&c=config_form title=\" \">total</a> : $gNoOfData  articles : $gCurPage/$gTotPage</font>\n";
	print "</td></tr></table>\n";
}

sub PageFooter {
	print "";
}

sub showInputForm {
	local($data,$subject,$content,$name,$url,$value);
	local(@value,@cookies);
    
	if($ENV{'HTTP_COOKIE'}) {
		@cookies = split(/; /,$ENV{'HTTP_COOKIE'});
		foreach(@cookies) {
			($name,$value) = split(/=/,$_);
			$COOKIE{$name} = $value;
		}
	}
 
	&HTMLHeader;

	print "<form method=post action=$gCGI_URL>\n";    
	print "<table border=0 cellpadding=2 cellspacing=0>\n";    
	print "<input type=hidden name=id value=$FORM{'id'}>\n";
	print "<input type=hidden name=action value=write>\n";
	print "<input type=hidden name=n value=$FORM{'n'}>\n";
	print "<input type=hidden name=p value=1>\n";
	print "<tr><td align=center colspan=2>\n";
	print "<input name=subject value=\" \" type=text size=60 maxlength=40 style=\"border:1 solid $gBaseText; background:;\" onblur=checkField(this) onfocus=clearField(this)>\n";
	print "</td></tr>\n";
	print "<tr><td align=center colspan=2>\n";
	print "<textarea name=content rows=12 cols=59 style=\"border:1 solid $gBaseText; background:;\" onblur=checkField(this) onfocus=clearField(this)> </textarea>\n";
	print "</td></tr>\n";
	print "<tr><td align=center colspan=2>\n";
	print "<input name=url value=\" ũ\" type=text size=60 maxlength=80 style=\"border:1 solid $gBaseText; background:;\" onblur=checkField(this) onfocus=clearField(this)>\n";
	print "</td></tr>\n";
	print "<tr><td>\n";
	print "&nbsp;&nbsp;<font style=\"font-size:8pt;font-family:Tahoma\"><input type=checkbox name=autolink value=enable checked> auto link enable <input type=checkbox name=html value=enable> html enable</font>\n";
	print "</td><td align=right>\n";
	print "<input type=submit value=ϱ style=\"border:1 solid $gBaseText; background:;\">\n";
	print "&nbsp;<input type=reset value=ϱ style=\"border:1 solid $gBaseText; background:;\">&nbsp;&nbsp;\n";
	print "</td></tr>\n";
	print "</table>\n";
	print "</form>\n";

	&HTMLFooter;
}

sub writeData {
	&getNumber;
	&getVariable;

	&makeCryptPassword if($passwd);
	&makeNewFile;
	&appendIndexFile;
	&sendMail if($gAdminEmail);
	$gNoOfData++;
	&putNumber;

	$gDelayTime = 500;
	&HTMLHeader;
		print "<p>Խù  Ͽϴ\n";
		print "<p>[<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'} onfocus=\"this.blur()\"></a>]\n";
	&HTMLFooter;
}

sub getVariable {
	if($FORM{'passwd'}) {
		$passwd = "$FORM{'passwd'}";
	}
	unless($FORM{'subject'} =~ /^\s*$/) {
		$subject = "$FORM{'subject'}";
		if($FORM{'subject'} eq ' ') {
			&error(no_subject);
		}
		else {
			$subject =~ s/</&lt;/g;
			$subject =~ s/>/&gt;/g;
			$subject =~ s/"/&quot;/g;
			$subject =~ s/\|/&#124;/g;
		}
	}
	else {
		&error(no_subject);
	}
	if($FORM{'content'}) {
		$content = "$FORM{'content'}";
		if($FORM{'content'} eq ' ') {
			&error(no_content);
		}
		else {
			if($FORM{'html'} ne "enable") { 
				$content =~ s/</&lt;/g;
				$content =~ s/>/&gt;/g;
				$content =~ s/"/&quot;/g;
				$content =~ s/\|/&#124;/g;
			}
			if ($FORM{'autolink'} eq "enable"){
				$content =~ s/(http:\/\/)([\w\+\-\/\=\?\.\~]+\.gif)/<img src=\"\/\/$2\">/gi;
				$content =~ s/(http:\/\/)([\w\+\-\/\=\?\.\~]+\.jpg)/<img src=\"\/\/$2\">/gi;
				$content =~ s/(http:\/\/)([\w\+\-\/\=\?\.\~]+\.bmp)/<img src=\"\/\/$2\">/gi;
				$content =~ s/(http:\/\/)([\w\~+\-\/\=\?\.\~\:]+)/<a href=\"$1$2\" target=_blank>$1$2<\/a>/gi;
				$content =~ s/(ftp:\/\/)([\w\~+\-\/\=\?\.\~]+)/<a href=\"$1$2\" target=_blank>$1$2<\/a>/gi;
				$content =~ s/(telnet:\/\/)([\w\~+\-\/\=\?\.\~]+)/<a href=\"$1$2\" target=_blank>$1$2<\/a>/gi;
				$content =~ s/([\w\-]+\@[\w\-+\.]+[\w\-]+)/<a href=\"mailto:$1\">$1<\/a>/gi;
			}
			$content =~ s/\r\n\r\n/<p>/g;
			$content =~ s/\r\n/<br>/g;
			$content =~ s/\|/&#124;/g;
		}
	}
	else {
		&error(no_content);
	}
	if($FORM{'url'}) {
		$url = "$FORM{'url'}";
		if($FORM{'url'} eq ' ũ') {
			$url = "";
		}
		else {
			$url =~ s/\|/&#124;/g;
		}
	}
	else {
		$url = "";
	}
	&getDate;
}

sub getDate {     

	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	
	if($sec < 10) {
		$sec = "0$sec";
	}
	if($min < 10) {
		$min = "0$min";
	}
	if($hour < 10) {
		$hour = "0$hour";
	}
	$mon++;
	if($mon < 10) {
		$mon = "0$mon";
	}
	if($mday < 10) {
		$mday = "0$mday";
	}
	if($year > 99) {
		$year = 1900+$year;}
	else{
		$year = "19$year"; } 

	$date = "$year-$mon-$mday $hour:$min:$sec";
	$d = "$mon$mday";
}  

sub makeCryptPassword  {
	local($crypt_code);
	local(@set);

	@set = ('a'..'z','A'..'Z','0'..'9','.','/');
	$crypt_code = "$set[9]$set[3]";
	$gCryptPassword = crypt($passwd,$crypt_code);
}

sub makeNewFile { 
	local(@set);

	@set = ('0'..'9'); 
	srand(time);
	$gRandomFilename = "$d$set[rand(10)]$set[rand(10)]$set[rand(10)]$set[rand(10)]";
	open(HANDLE,">$gBaseDIR/messages/$gRandomFilename.txt");
		print HANDLE "$gCryptPassword|$gRandomFilename|$name|$url|$date|$subject|$content|\n";
	close(HANDLE);
}

sub appendIndexFile {
	local($data);
	local(@datum,@point);

	&lock;
	open(HANDLE,"$gBaseDIR/$gDatFile");
		@datum = <HANDLE>;
	close(HANDLE);
    
	if($FORM{'l'}) {    
		open(HANDLE,">$gBaseDIR/$gDatFile");
		foreach $data (@datum) {
			@point = split(/\|/,$data);
			if($point[1] eq $FORM{'l'}) {
				$thread = $point[0] + 1;
				print HANDLE "$data";
				print HANDLE "$thread|$gRandomFilename|$subject|$name|$url|$date|0|$content|\n";
			}
			else {
				print HANDLE "$data";
			}
		}
		close(HANDLE);
	}
	else {
		open(HANDLE,">$gBaseDIR/$gDatFile");
		foreach $data (@datum) {
			if($data =~ /<!--EOF-->/) {
				print HANDLE "<!--EOF-->\n";
				print HANDLE "0|$gRandomFilename|$subject|$name|$url|$date|0|$content|\n";
			}
			else {
				print HANDLE "$data";
			}
		}
		close(HANDLE);
	}
	&unlock;
}

sub error {
	local($error) = $_[0];
    
	&HTMLHeader;
	if ($error eq "no_subject") {
		print "<p> ݵ ؾ մϴ\n";
		print "<p>[<a href=\"javascript:history.back()\" onfocus=\"this.blur()\">ڷ</a>]\n";
	}
	else {
		print "<p> ݵ ؾ մϴ\n";
		print "<p>[<a href=\"javascript:history.back()\" onfocus=\"this.blur()\">ڷ</a>]\n";
	}
	&HTMLFooter;
}

sub showUsersLogin {
	local($command);

	if($FORM{'c'} eq "delete") {
		$command = "delete";
	}
	else {
		$command = "update_form";
	}
 
	&HTMLHeader;

	print "<form method=post action=$gCGI_URL>\n";
	print "<input type=hidden name=id value=$FORM{'id'}>\n"; 
	print "<input type=hidden name=p value=$FORM{'p'}>\n";
	print "<input type=hidden name=action value=$command>\n";
	print "<input type=hidden name=l value=$FORM{'l'}>\n";
	print "<p>  Դϴ<br>\n";
	print "<input type=password name=passwd size=25 maxlength=8 style=\"border:1 solid $gBaseText; background:;\">\n";
	print "<p><input type=submit value=ϱ style=\"border:1 solid $gBaseText; background:;\">\n" if($command eq "delete");
	print "<p><input type=submit value=ϱ style=\"border:1 solid $gBaseText; background:;\">\n" if($command eq "update_form");
	print "</form>\n";

	&HTMLFooter;       
}

sub checkUserPassword {
	local($data,$crypt_code,$save_password,$crypt_password);
	local(@passwd,@set,@datum,@value);
 
	open(HANDLE,"$gBaseDIR/messages/$FORM{'l'}.txt");
		$data = <HANDLE>;
	close(HANDLE);
	@passwd = split(/\|/,$data);

	open(HANDLE,"$gBaseDIR/$gPwdFile");
		$save_password = <HANDLE>;
	close(HANDLE);
	chop($save_password);

	@set = ('a'..'z','A'..'Z','0'..'9','.','/');
	$crypt_code = "$set[9]$set[3]";
	$crypt_password = crypt($FORM{'passwd'},$crypt_code);

	unless($crypt_password eq $passwd[0] || $crypt_password eq $save_password) {
		&HTMLHeader;
			print "<p> йȣ ġ ϴ\n";        
			print "<p>[<a href=\"javascript:history.back()\" onfocus=\"this.blur()\">ڷ</a>]\n";
		&HTMLFooter;
	} 
}

sub deleteData {
	local($delete_filename);
	local(@datum,@value);
 
	open(HANDLE,"$gBaseDIR/$gDatFile");
		@datum = <HANDLE>;
	close(HANDLE);
	open(HANDLE,">$gBaseDIR/$gDatFile");
	foreach $data (@datum) {
		@value = split(/\|/, $data);
		if($FORM{'l'} != $value[1]) {
			print HANDLE "$data";             
		}
		else {
			$delete_filename = $value[7];
		}
	}
	close(HANDLE);

	unlink("$gBaseDIR/messages/$FORM{'l'}.txt");
	unlink("$gBaseDIR/files/$delete_filename");
	&getNumber;
	$gNoOfData--;
	&putNumber;

	&unlock;

	$gDelayTime = 1000;
	&HTMLHeader;
		print "<p>Խù Ǿϴ\n";
		print "<p>[<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'} onfocus=\"this.blur()\"></a>]\n";
	&HTMLFooter;
}

sub showUpdateForm {
	local($data,$name,$value);
	local(@cookies);
    
	local(@value);
	if($ENV{'HTTP_COOKIE'}) {
		@cookies = split(/; /,$ENV{'HTTP_COOKIE'});
		foreach(@cookies) {
			($name,$value) = split(/=/,$_);
			$COOKIE{$name} = $value;
		}
	}
 
	open(HANDLE,"$gBaseDIR/messages/$FORM{'l'}.txt");
		$data = <HANDLE>;
	close(HANDLE);
	@value = split(/\|/,$data);             

	&HTMLHeader;

	print "<form method=post action=$gCGI_URL>\n";    
	print "<table border=0 cellpadding=2 cellspacing=0>\n";    
	print "<input type=hidden name=id value=$FORM{'id'}>\n"; 
	print "<input type=hidden name=action value=update>\n";
	print "<input type=hidden name=p value=$FORM{'p'}>\n";
	print "<input type=hidden name=l value=$FORM{'l'}>\n";
	print "<tr><td align=center colspan=2>\n";
	print "<input name=subject value=\"$value[5]\" type=text size=60 maxlength=40 style=\"border:1 solid $gBaseText; background:;\">\n";
	print "</td></tr>\n";
	print "<tr><td align=center colspan=2>\n";
	$value[6] =~ s/<br>/\n/g;
	$value[6] =~ s/<p>/\n\n/g;
	print "<textarea name=content rows=12 cols=59 style=\"border:1 solid $gBaseText; background:;\">$value[6]</textarea>\n";
	print "</td></tr>\n";
	print "<tr><td align=center colspan=2>\n";
	print "<input name=url value=\"$value[3]\" type=text size=60 maxlength=80 style=\"border:1 solid $gBaseText; background:;\">\n";
	print "</td></tr>\n";
	print "<tr><td>\n";
	print "&nbsp;&nbsp;<font style=\"font-size:8pt;font-family:Tahoma\"><input type=checkbox name=autolink value=enable checked> auto link enable <input type=checkbox name=html value=enable> html enable</font>\n";
	print "</td><td align=right>\n";
	print "<input type=submit value=ϱ style=\"border:1 solid $gBaseText; background:;\">\n";
	print "&nbsp;<input type=reset value=ϱ style=\"border:1 solid $gBaseText; background:;\">&nbsp;&nbsp;\n";
	print "</td></tr>\n";
	print "</table>\n";
	print "</form>\n";

	&HTMLFooter;       
}

sub updateData {
	local(@datum,@value);

	&getVariable;
	open(HANDLE,"<$gBaseDIR/$gDatFile");
		@datum = <HANDLE>;
	close(HANDLE);

	open(HANDLE,">$gBaseDIR/$gDatFile");
	foreach $data (@datum) {
		@value = split(/\|/,$data);
		if($FORM{'l'} eq $value[1]) {
			print HANDLE "$value[0]|$FORM{'l'}|$subject|$name|$url|$value[5]|$value[6]|$content|\n";
		}
		else {
			print HANDLE "$data";
		}
	}
	close(HANDLE);
	open(HANDLE,">$gBaseDIR/messages/$FORM{'l'}.txt");
		print HANDLE "$FORM{'OldPassword'}|$FORM{'l'}|$name|$url|$value[5]|$subject|$content|\n";
	close(HANDLE);

	&unlock;
	$gDelayTime = 1000;
	&HTMLHeader;
		print "<p>Խù  Ǿϴ\n";
		print "<p>[<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'} onfocus=\"this.blur()\"></a>]\n";
	&HTMLFooter;
}

sub showAdminLogin {

	&HTMLHeader;

	unless(open(HANDLE,"$gBaseDIR/$gPwdFile")) {
		print "<form action=$gCGI_URL>\n";
		print "<input type=hidden name=id value=$FORM{'id'}>\n";    
		print "<input type=hidden name=action value=$FORM{'c'}>\n";
		print "<input type=hidden name=p value=$FORM{'p'}>\n";
		print "<input type=hidden name=ps value=new>\n";
		print "<br><br> йȣ ϼ<br>\n";
		print " йȣ <input type=password name=newpasswd size=20 maxlength=8 style=\"border:1 solid $gBaseText; background:;\"><br>\n";
		print "йȣ Է <input type=password name=repasswd size=20 maxlength=8 style=\"border:1 solid $gBaseText; background:;\"><br><br>\n";
		print "<input type=submit value=ϱ style=\"border:1 solid $gBaseText; background:;\">\n";
		print "</form>\n";
	}
	else {
		print "<form method=post action=$gCGI_URL>\n";
		print "<input type=hidden name=id value=$FORM{'id'}>\n"; 
		print "<input type=hidden name=action value=$FORM{'c'}>\n";
		print "<input type=hidden name=p value=$FORM{'p'}>\n";
		print "<input type=hidden name=ps value=old>\n";
		print "<br><br>  Դϴ\n";
		print "<br><input type=password name=oldpasswd size=25 maxlength=8 style=\"border:1 solid $gBaseText; background:;\"><br>\n";
		print "<select name=action style=\"border:1 solid $gBaseText; background:$gBackColor;\">";
		print "<option value=$FORM{'c'}> α";
		print "<option value=input_form selected> ۾";
		print "</select>\n";
		print "<br><br><input type=submit value=ϱ style=\"border:1 solid $gBaseText; background:;\">\n";
		print "</form>\n";
	}

    &HTMLFooter;

	close(HANDLE);
}
 
sub checkAdminPassword {
	local($crypt_code,$save_password,$old_password,$new_password);
	local(@set);
    
	if($FORM{'ps'} eq "new") {  
		if($FORM{'newpasswd'} eq $FORM{'repasswd'}) {
			if($FORM{'newpasswd'} ne "") {
				@set = ('a'..'z','A'..'Z','0'..'9','.','/');
				$crypt_code = "$set[9]$set[3]";
				$save_password = crypt($FORM{'newpasswd'},$crypt_code);
				open(HANDLE,">$gBaseDIR/$gPwdFile");
					print HANDLE "$save_password\n";
				close(HANDLE);
			}
			else {
				&HTMLHeader;
					print "<p> йȣ ġ ϴ\n";
					print "<p>[<a href=\"javascript:history.back()\" onfocus=\"this.blur()\">ڷ</a>]\n";
				&HTMLFooter;
			}
		}
		else {
			&HTMLHeader;
				print "<p> йȣ Է ʾϴ\n";
				print "<p>[<a href=\"javascript:history.back()\" onfocus=\"this.blur()\">ڷ</a>]\n";
			&HTMLFooter;
		} 
	} 
	else { 
		open(HANDLE,"<$gBaseDIR/$gPwdFile");
			$save_password = <HANDLE>;
		close(HANDLE);
		chop($save_password);

		@set = ('a'..'z','A'..'Z','0'..'9','.','/');
		$crypt_code = "$set[9]$set[3]";
		$old_password = crypt($FORM{'oldpasswd'},$crypt_code);

		unless($old_password eq $save_password) {
			&HTMLHeader;
				print "<p> йȣ ġ ϴ\n";
				print "<p>[<a href=\"javascript:history.back()\" onfocus=\"this.blur()\">ڷ</a>]\n";
			&HTMLFooter;
		}
	}
}

sub checkConfigPassword {
	local($crypt_code,$save_password,$old_password,$new_password,$cur_passwd);
	local(@set);
 
	open(HANDLE,"<$gBaseDIR/$gPwdFile");
		$save_password = <HANDLE>;
	close(HANDLE);
	chop($save_password);

	@set = ('a'..'z','A'..'Z','0'..'9','.','/');
	$crypt_code = "$set[9]$set[3]";
	$old_password = crypt($FORM{'oldpasswd'},$crypt_code);

	unless($old_password eq $save_password) {
		&HTMLHeader;
			print "<p>ȯ    йȣ ġ ϴ.\n";
			print "<p>[<a href=\"javascript:history.back()\" onfocus=\"this.blur()\">ڷ</a>]\n";
		&HTMLFooter;
	}
}

sub showConfigForm {

    &HTMLHeader;

	print "<form action=$gCGI_URL>\n";
	print "<input type=hidden name=id value=$FORM{'id'}>\n";
	print "<input type=hidden name=action value=config>\n";
	print "<input type=hidden name=p value=$FORM{'p'}>\n";
	print "<input type=hidden name=ps value=new>\n";
	print "<p><table width=500 border=1 cellspacing=0 cellpadding=4 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#e3e3e3><tr><td><b> :::  ȣ  ::: </b></td></tr></table>";
	print "<table width=500 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#f3f3f3><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0 bgcolor=#f3f3f3>\n";    
	print "<tr><td>ο йȣ</td><td align=right><input type=password name=newpasswd size=10 maxlength=8></td></tr>\n";
	print "<tr><td>йȣ Է</td><td align=right><input type=password name=repasswd size=10 maxlength=8></td></tr>\n";
	if($gMakeBoard eq "Y") {
		$gMakeBoard = "";
	} 
	else {
		$gMakeBoard = "";
	}
	print "<tr><td align=right> ߰ : </td><td><font color=#ff0000>$gMakeBoard</font>\n";
	print "</td></tr></table></td></tr></table>\n";
	print "<p><table width=500 border=1 cellspacing=0 cellpadding=4 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#e3e3e3><tr><td><b> :::    ::: </b></td></tr></table>";
	print "<table width=500 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#f3f3f3><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0 bgcolor=#f3f3f3>\n";    
	print "<tr><td> </td><td align=right><input type=text name=BackColor value=\"$gBackColor\" size=10></td></tr>\n";
	print "<tr><td> ׸</td><td align=right><input type=text name=BackImage value=\"$gBackImage\" size=40></td></tr>\n";
	print "</table></td></tr></table>\n";
	print "<p><table width=500 border=1 cellspacing=0 cellpadding=4 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#e3e3e3><tr><td><b> :::    ::: </b></td></tr></table>";
	print "<table width=500 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#f3f3f3><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0 bgcolor=#f3f3f3>\n";    
	print "<tr><td> </td><td align=right><input type=text name=BoardTitle value=\"$gBoardTitle\" size=40></td></tr>\n";
	print "<tr><td> ׸</td><td align=right><input type=text name=BoardImage value=\"$gBoardImage\" size=40></td></tr>\n";
	print "</table></td></tr></table>\n";
	print "<p><table width=500 border=1 cellspacing=0 cellpadding=4 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#e3e3e3><tr><td><b> ::: ⺻ ȯ  ::: </b></td></tr></table>";
	print "<table width=500 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#c0c0c0><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0 bgcolor=#f3f3f3>\n";    
	print "<tr><td>⺻  </td><td align=right><input type=text name=BaseText value=\"$gBaseText\" size=10></td></tr>\n";
	print "<tr><td>⺻  ũ</td><td align=right><input type=text name=TextSize value=\"$gTextSize\" size=10>\n";
	print "<tr><td>⺻ ۲</td><td align=right><input type=text name=TextFamily value=\"$gTextFamily\" size=10>\n";
	print "<tr><td>ũ </td><td align=right><input type=text name=Link value=\"$gLink\" size=10></td></tr>\n";
	print "<tr><td>湮 ũ </td><td align=right><input type=text name=LinkVisited value=\"$gLinkVisited\" size=10></td></tr>\n";
	print "<tr><td>Ȱȭ ũ </td><td align=right><input type=text name=LinkActive value=\"$gLinkActive\" size=10></td></tr>\n";
	print "<tr><td>ũ Ϲ </td><td align=right><input type=text name=LinkHover value=\"$gLinkHover\" size=10></td></tr>\n";
	print "<tr><td>¥  </td><td align=right><input type=text name=DateText value=\"$gDateText\" size=10></td></tr>\n";
	print "<tr><td>  </td><td align=right><input type=text name=SubjectText value=\"$gSubjectText\" size=10></td></tr>\n";
	print "<tr><td>  </td><td align=right><input type=text name=ContentText value=\"$gContentText\" size=10></td></tr>\n";
	print "</table></td></tr></table>\n";
	print "<p><table width=500 border=1 cellspacing=0 cellpadding=4 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#e3e3e3><tr><td><b> ::: Ÿ   ::: </b></td></tr></table>";
	print "<table width=500 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#f3f3f3><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0 bgcolor=#f3f3f3>\n";    
	print "<tr><td> </td><td align=right><input type=text name=TableWidth value=\"$gTableWidth\" size=10></td></tr>\n";
	print "<tr><td>Խù ¼</td><td align=right><input type=text name=RecPerPage value=\"$gRecPerPage\" size=10>\n";
	print "<tr><td>ٷΰ </td><td align=right><input type=text name=ListNumber value=\"$gListNumber\" size=10>\n";
	print "</table></td></tr></table>\n";
	print "<p><input type=submit value=ϱ style=\"border:1 solid $gBaseText; background:;\">\n";
	print "</form>\n";
	print "</tr></td></table>\n";

    &HTMLFooter;
}

sub updateEnvVar {
	&checkAdminPassword if($FORM{'newpasswd'} || $FORM{'repassword'});

	$gBackColor = $FORM{'BackColor'};
	$gBackImage = $FORM{'BackImage'} if($FORM{'BackImage'} =~ /^http:\/\// || $FORM{'BackImage'} eq "");
	$gBoardTitle = $FORM{'BoardTitle'};
	$gBoardImage = $FORM{'BoardImage'} if($FORM{'BoardImage'} =~ /^http:\/\// || $FORM{'TitleImage'} eq "");
	$gTableWidth = $FORM{'TableWidth'}; 
	$gRecPerPage = $FORM{'RecPerPage'} if($FORM{'RecPerPage'} >= 1);
	$gListNumber = $FORM{'ListNumber'};
	$gBaseText = $FORM{'BaseText'};
	$gTextSize = $FORM{'TextSize'};
	$gTextFamily = $FORM{'TextFamily'};
	$gLink = $FORM{'Link'};
	$gLinkVisited = $FORM{'LinkVisited'};
	$gLinkActive = $FORM{'LinkActive'};
	$gLinkHover = $FORM{'LinkHover'};
	$gSubjectText = $FORM{'SubjectText'};
	$gContentText = $FORM{'ContentText'};
	$gDateText = $FORM{'DateText'};

	&putEnvVar;
	$gCurPage = $FORM{'p'};
	&readData;
}

sub lock {
	local($LockFile) = "$gBaseDIR/lock.txt";
	local($EndTime) = time+45;

	while(-e $LockFile && time < $EndTime) {}
	open(LOCK,">$LockFile");
	chmod 0666,$LockFile;

	if($gLockFlag eq 'Y') {
		flock(LOCK,2);
	}
	$gLockStat = 'Y';
}    

sub unlock {
	local($LockFile) = "$gBaseDIR/lock.txt";

	if($gLockStat eq 'Y') {
		if($gLockFlag eq 'Y') {
			flock(LOCK,8); 
		}
		close(LOCK);
		if(-e $LockFile) { 
			unlink($LockFile);
		}
	$gLockStat = 'N'; 
	}
}